/*  @(#)ICFS.H 1.00, Dirk Haun @ WI2, 06.08.1995
 */

#define ICF_GETSIZE     0x0000  /* Fenstergre, Version abfragen  */
#define ICF_GETPOS      0x0001  /* Fensterposition anfordern       */
#define ICF_FREEPOS     0x0002  /* Fensterposition freigeben       */
#define ICF_SNAP        0x0003  /* Fenster verschieben             */
#define ICF_GETBIGPOS   0x0004  /* groes Fenster anfordern        */
#define ICF_GETLOC      0x0005  /* Fensterposition abfragen        */
#define ICF_GETWPOS     0x0021  /* Fensterposition anfordern       */
#define ICF_FREEWPOS    0x0022  /* Fensterposition freigeben       */
#define ICF_SNAPW       0x0023  /* Fenster verschieben             */
#define ICF_GETBIGWPOS  0x0024  /* groes Fenster anfordern        */
#define ICF_GETWLOC     0x0025  /* Fensterposition abfragen        */
#define ICF_FREEALL     0x0100  /* alle Positionen freigeben       */
#define ICF_SCREEN      0x0101  /* Bildschirmgre bergeben       */
#define ICF_NEXTPOS     0x0102  /* nchste freie Position erfragen */
#define ICF_INFO        0x0200  /* Einstellungen abfragen          */
#define ICF_CONFIG      0x0201  /* Konfiguration ndern            */
#define ICF_SETSIZE     0x0202  /* Fenstergre ndern             */
#define ICF_SETSPACE    0x0203  /* Fensterabstand ndern           */
#define ICF_SETBORDER   0x0204  /* Abstand zum Bildschirmrand      */
#define ICF_NEXTINFO    0x02A0  /* neue Einstellungen abfragen     */
#define ICF_WINOPEN     0x02A1  /* Anzahl offener Fenster abfragen */
#define ICF_GETPATH     0x0300  /* Pfad fr ICFS.PRG erfragen      */

struct _conf
{
 unsigned reserved : 11; /* unbenutzt, sollte 0 sein               */
 unsigned snap     : 1;  /* Bit 4: 1=Snapping ein                  */
 unsigned bigics   : 1;  /* Bit 3: 1=groe Icon-Fenster erlaubt    */
 unsigned yfirst   : 1;  /* Bit 2: 1=zuerst in y-Richtung          */
 unsigned right    : 1;  /* Bit 1: 1=rechts anfangen               */
 unsigned top      : 1;  /* Bit 0: 1=oben anfangen                 */
};

typedef struct
{
 unsigned int version; /* Versionsnummer als BCD (0x0010 fr 0.10) */
 struct _conf config;  /* Konfigurationsbits, siehe oben           */
 int xsize, ysize,     /* Breite und Hhe des Fensters, default=72 */
     xspace, yspace,   /* Abstand zwischen Fenstern, default=0     */
     xborder, yborder; /* Abstand vom Bildschirmrand, default=0    */
} ICFSCONFIG;
